/*
 * ioreplay, a vbtracetool trace replayer. use with care
 *
 * Copyright 2008 Stuart Bennett <sb476@cam.ac.uk>
 *
 * This program is released under the terms of the GNU General Public License, version 2
 */

#include <stdio.h>
#include <sys/io.h>

#define __BUILDIO(bwl,bw,type) \
static inline void out##bwl##_local(unsigned long port, unsigned type value) {        __asm__ __volatile__("out" #bwl " %" #bw "0, %w1" : : "a"(value), "Nd"(port)); \
}\
static inline unsigned type in##bwl##_local(unsigned long port) { \
        unsigned type value; \
        __asm__ __volatile__("in" #bwl " %w1, %" #bw "0" : "=a"(value) : "Nd"(port)); \
        return value; \
}\

__BUILDIO(b,b,char)
__BUILDIO(w,w,short)
__BUILDIO(l,,int)

int main(int argc, char *argv[])
{
	FILE *io;
	char line[100];
	int port, data;

	ioperm(0, 1024, 1);
	iopl(3);

	if (!(io = fopen(argv[1], "r"))) {
		printf("File open failed\n");
		return 1;
	}

	while (!feof(io)) {
		if (!fgets(line, 100, io))
			return 0;

		if (line[10] != 'W') {
#if 0
			// slow shit down
			volatile int i;
			for (i = 0; i < 10000; i++)
				;
#endif
			continue;
		}

		sscanf(line, "%*x:%*x	W%*d  port: %x data: %x", &port, &data); 

		if (line[11] == '3')
			outl_local(port, data);
		else if (line[11] == '1')
			outw_local(port, data);
		else
			outb_local(port, data);
	}

	return 0;
}
